IMPLEMENTATION MODULE MathLib0;

(**************************************************************************
   JAVA      Modula-2 floating point library for elemetary functions.

   Copyright (c) 1998 by Mill Hill & Canterbury Corporation, Ltd.
**************************************************************************)


IMPORT SYSTEM, java_lang_Math;


FROM SYSTEM IMPORT INLINE;

CONST
  IsLongReal = SIZE( LONGREAL ) = SIZE( REAL );

VAR
  m : java_lang_Math.Math;



PROCEDURE sqrt( x : REAL ) : REAL;
BEGIN
  (*$IF IsLongReal *)
  RETURN m.sqrt(x);
  (*$ELSE *)
  RETURN SHORT( m.sqrt(x) );
  (*$ENDIF *)
END sqrt;


PROCEDURE exp( x : REAL ) : REAL;
BEGIN
  (*$IF IsLongReal *)
  RETURN m.exp(x);
  (*$ELSE *)
  RETURN SHORT( m.exp(x) );
  (*$ENDIF *)
END exp;



PROCEDURE ln( x : REAL ) : REAL;
BEGIN
  (*$IF IsLongReal *)
  RETURN m.log(x);
  (*$ELSE *)
  RETURN SHORT( m.log(x) );
  (*$ENDIF *)
END ln;


PROCEDURE sin( x : REAL ) : REAL;
BEGIN
  (*$IF IsLongReal *)
  RETURN m.sin(x);
  (*$ELSE *)
  RETURN SHORT( m.sin(x) );
  (*$ENDIF *)
END sin;


PROCEDURE cos( x : REAL ) : REAL;
BEGIN
  (*$IF IsLongReal *)
  RETURN m.cos(x);
  (*$ELSE *)
  RETURN SHORT( m.cos(x) );
  (*$ENDIF *)
END cos;


PROCEDURE arctan( x : REAL ) : REAL;
BEGIN
  (*$IF IsLongReal *)
  RETURN m.atan(x);
  (*$ELSE *)
  RETURN SHORT( m.atan(x) );
  (*$ENDIF *)
END arctan;


PROCEDURE real( x : LONGINT ) : REAL;
BEGIN
  RETURN FLOAT( x );
END real;


PROCEDURE entier( x : REAL ) : LONGINT;
BEGIN
  RETURN LONGTRUNC( x );
END entier;


END MathLib0.
